/*
 * generated by Xtext 2.26.0
 */
package de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.serializer;

import com.google.inject.Inject;
import de.cau.cs.kieler.tutorials.fdl22.turingmachine.text.services.MyDslGrammarAccess;
import de.cau.cs.kieler.tutorials.klighd.turingmachine.State;
import de.cau.cs.kieler.tutorials.klighd.turingmachine.Transition;
import de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringMachine;
import de.cau.cs.kieler.tutorials.klighd.turingmachine.TuringmachinePackage;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class MyDslSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private MyDslGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == TuringmachinePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case TuringmachinePackage.STATE:
				sequence_State(context, (State) semanticObject); 
				return; 
			case TuringmachinePackage.TRANSITION:
				sequence_Transition(context, (Transition) semanticObject); 
				return; 
			case TuringmachinePackage.TURING_MACHINE:
				sequence_TuringMachine(context, (TuringMachine) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     State returns State
	 *
	 * Constraint:
	 *     (initial?='initial'? final?='final'? name=EString (outgoingTransitions+=Transition outgoingTransitions+=Transition*)?)
	 * </pre>
	 */
	protected void sequence_State(ISerializationContext context, State semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Transition returns Transition
	 *
	 * Constraint:
	 *     (trigger=EString action=Action newChar=EString direction=Direction targetState=[State|EString])
	 * </pre>
	 */
	protected void sequence_Transition(ISerializationContext context, Transition semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, TuringmachinePackage.Literals.TRANSITION__TRIGGER) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TuringmachinePackage.Literals.TRANSITION__TRIGGER));
			if (transientValues.isValueTransient(semanticObject, TuringmachinePackage.Literals.TRANSITION__ACTION) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TuringmachinePackage.Literals.TRANSITION__ACTION));
			if (transientValues.isValueTransient(semanticObject, TuringmachinePackage.Literals.TRANSITION__NEW_CHAR) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TuringmachinePackage.Literals.TRANSITION__NEW_CHAR));
			if (transientValues.isValueTransient(semanticObject, TuringmachinePackage.Literals.TRANSITION__DIRECTION) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TuringmachinePackage.Literals.TRANSITION__DIRECTION));
			if (transientValues.isValueTransient(semanticObject, TuringmachinePackage.Literals.TRANSITION__TARGET_STATE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, TuringmachinePackage.Literals.TRANSITION__TARGET_STATE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getTransitionAccess().getTriggerEStringParserRuleCall_2_0(), semanticObject.getTrigger());
		feeder.accept(grammarAccess.getTransitionAccess().getActionActionEnumRuleCall_4_0(), semanticObject.getAction());
		feeder.accept(grammarAccess.getTransitionAccess().getNewCharEStringParserRuleCall_5_0(), semanticObject.getNewChar());
		feeder.accept(grammarAccess.getTransitionAccess().getDirectionDirectionEnumRuleCall_7_0(), semanticObject.getDirection());
		feeder.accept(grammarAccess.getTransitionAccess().getTargetStateStateEStringParserRuleCall_9_0_1(), semanticObject.eGet(TuringmachinePackage.Literals.TRANSITION__TARGET_STATE, false));
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     TuringMachine returns TuringMachine
	 *
	 * Constraint:
	 *     (states+=State states+=State*)
	 * </pre>
	 */
	protected void sequence_TuringMachine(ISerializationContext context, TuringMachine semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
